/**
 * generated by Xtext 2.27.0
 */
package org.eclipse.papyrus.robotics.assertions.languages.stl.stlText.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.papyrus.robotics.assertions.languages.stl.stlText.StlTextPackage;
import org.eclipse.papyrus.robotics.assertions.languages.stl.stlText.num_literal;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>num literal</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.papyrus.robotics.assertions.languages.stl.stlText.impl.num_literalImpl#getIlit <em>Ilit</em>}</li>
 *   <li>{@link org.eclipse.papyrus.robotics.assertions.languages.stl.stlText.impl.num_literalImpl#getRlit <em>Rlit</em>}</li>
 *   <li>{@link org.eclipse.papyrus.robotics.assertions.languages.stl.stlText.impl.num_literalImpl#getLit <em>Lit</em>}</li>
 * </ul>
 *
 * @generated
 */
public class num_literalImpl extends intervalTimeImpl implements num_literal
{
  /**
   * The default value of the '{@link #getIlit() <em>Ilit</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getIlit()
   * @generated
   * @ordered
   */
  protected static final String ILIT_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getIlit() <em>Ilit</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getIlit()
   * @generated
   * @ordered
   */
  protected String ilit = ILIT_EDEFAULT;

  /**
   * The default value of the '{@link #getRlit() <em>Rlit</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRlit()
   * @generated
   * @ordered
   */
  protected static final String RLIT_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getRlit() <em>Rlit</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getRlit()
   * @generated
   * @ordered
   */
  protected String rlit = RLIT_EDEFAULT;

  /**
   * The cached value of the '{@link #getLit() <em>Lit</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getLit()
   * @generated
   * @ordered
   */
  protected num_literal lit;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected num_literalImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return StlTextPackage.Literals.NUM_LITERAL;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String getIlit()
  {
    return ilit;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setIlit(String newIlit)
  {
    String oldIlit = ilit;
    ilit = newIlit;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, StlTextPackage.NUM_LITERAL__ILIT, oldIlit, ilit));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String getRlit()
  {
    return rlit;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setRlit(String newRlit)
  {
    String oldRlit = rlit;
    rlit = newRlit;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, StlTextPackage.NUM_LITERAL__RLIT, oldRlit, rlit));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public num_literal getLit()
  {
    return lit;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetLit(num_literal newLit, NotificationChain msgs)
  {
    num_literal oldLit = lit;
    lit = newLit;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, StlTextPackage.NUM_LITERAL__LIT, oldLit, newLit);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setLit(num_literal newLit)
  {
    if (newLit != lit)
    {
      NotificationChain msgs = null;
      if (lit != null)
        msgs = ((InternalEObject)lit).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - StlTextPackage.NUM_LITERAL__LIT, null, msgs);
      if (newLit != null)
        msgs = ((InternalEObject)newLit).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - StlTextPackage.NUM_LITERAL__LIT, null, msgs);
      msgs = basicSetLit(newLit, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, StlTextPackage.NUM_LITERAL__LIT, newLit, newLit));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case StlTextPackage.NUM_LITERAL__LIT:
        return basicSetLit(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case StlTextPackage.NUM_LITERAL__ILIT:
        return getIlit();
      case StlTextPackage.NUM_LITERAL__RLIT:
        return getRlit();
      case StlTextPackage.NUM_LITERAL__LIT:
        return getLit();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case StlTextPackage.NUM_LITERAL__ILIT:
        setIlit((String)newValue);
        return;
      case StlTextPackage.NUM_LITERAL__RLIT:
        setRlit((String)newValue);
        return;
      case StlTextPackage.NUM_LITERAL__LIT:
        setLit((num_literal)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case StlTextPackage.NUM_LITERAL__ILIT:
        setIlit(ILIT_EDEFAULT);
        return;
      case StlTextPackage.NUM_LITERAL__RLIT:
        setRlit(RLIT_EDEFAULT);
        return;
      case StlTextPackage.NUM_LITERAL__LIT:
        setLit((num_literal)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case StlTextPackage.NUM_LITERAL__ILIT:
        return ILIT_EDEFAULT == null ? ilit != null : !ILIT_EDEFAULT.equals(ilit);
      case StlTextPackage.NUM_LITERAL__RLIT:
        return RLIT_EDEFAULT == null ? rlit != null : !RLIT_EDEFAULT.equals(rlit);
      case StlTextPackage.NUM_LITERAL__LIT:
        return lit != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuilder result = new StringBuilder(super.toString());
    result.append(" (ilit: ");
    result.append(ilit);
    result.append(", rlit: ");
    result.append(rlit);
    result.append(')');
    return result.toString();
  }

} //num_literalImpl
